## acl2 6.0

=== Makefile ===
#; ACL2 Version 6.0 -- A Computational Logic for Applicative Common Lisp
#; Copyright (C) 2012, Regents of the University of Texas

#; This version of ACL2 is a descendent of ACL2 Version 1.9, Copyright
#; (C) 1997 Computational Logic, Inc.  See the documentation topic NOTES-2-0.

#; This program is free software; you can redistribute it and/or
#; modify it under the terms of Version 2 of the GNU General Public
#; License as published by the Free Software Foundation.

#; This program is distributed in the hope that it will be useful,
#; but WITHOUT ANY WARRANTY; without even the implied warranty of
#; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#; GNU General Public License for more details.

#; You should have received a copy of the GNU General Public License
#; along with this program; if not, write to the Free Software
#; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#; Written by:  Matt Kaufmann               and J Strother Moore
#; email:       Kaufmann@cs.utexas.edu      and Moore@cs.utexas.edu
#; Department of Computer Sciences
#; University of Texas at Austin
#; Austin, TX 78712-1188 U.S.A.

# This file certifies books by directing appropriate subdirectories to
# certify their books.  The subsidiary Makefiles take advantage of a
# makefile, Makefile-generic, in this directory, which is derived from
# one written by Bishop Brock.

# For example, to clean and time book certification (including workshops):
# make clean all-plus

# To see how one can certify the books in the regression suite using
# waterfall parallelism (requires the experimental extension ACL2(p)
# of ACL2), see file acl2-sources/acl2-customization-files/README.

# We do not set variable ACL2 here, because the value here would be
# overriden anyhow by the values in the subsidiary Makefiles, which get their
# value from file Makefile-generic.  However, ACL2 can be set on the command
# line, e.g.:
# make ACL2=acl2
# make ACL2=/usr/local/bin/acl2 TIME=/usr/bin/time
# make ACL2=/u/acl2/v2-9/acl2-sources/saved_acl2

TIME = time

# Avoid loading customization file unless environment variable is already set.
# (This is also done in Makefile-generic, but we do it here in support of the
# hons target.)
export ACL2_CUSTOMIZATION ?= NONE

export ACL2_PCERT

# Directories go here; first those before certifying arithmetic/top-with-meta,
# then those afterwards.

# NOTE!  This does *not* touch directory nonstd.

# Note: arithmetic-4 could be added in analogy to arithmetic-5.

DIRS1 = cowles arithmetic meta xdoc
DIRS2_EXCEPT_WK_COI = ordinals data-structures bdd ihs arithmetic-2 arithmetic-3 arithmetic-5 \
	misc models/jvm/m1-original models/jvm/m1 models/jvm/m5 \
proofstyles rtl arithmetic-3/extra sorting make-event parallel hints \
	fix-cert finite-set-theory finite-set-theory/osets powerlists textbook \
	defexec symbolic \
	data-structures/memories unicode str concurrent-programs/bakery \
	concurrent-programs/german-protocol deduction/passmore clause-processors \
	quadratic-reciprocity tools paco hacking security regex \
	defsort serialize wp-gen xdoc-impl system tutorial-problems cutil \
	countereg-gen demos leftist-trees taspi
# Add directories other than centaur that depend on hons, say, for performance:
HONS_ONLY_DIRS = models/y86 security/des
ifdef ACL2_HONS_REGRESSION
DIRS2_EXCEPT_WK_COI += $(HONS_ONLY_DIRS)
endif
DIRS2_EXCEPT_WK = $(DIRS2_EXCEPT_WK_COI) coi misc/misc2
DIRS2 = $(DIRS2_EXCEPT_WK) workshops
SHORTDIRS2 = ordinals data-structures bdd

# If ACL2_CENTAUR is already set then we leave it alone.  Otherwise
# we set ACL2_CENTAUR to `before' to obtain extra parallelism via the
# centaur/ books unless specific directories are specified, in which
# case we set ACL2_CENTAUR to `skip' to avoid certifying the centaur
# books needlessly.  (If a books directory depends on the centaur
# books, then its dependency should be recorded among the long list of
# dependencies below.)
ifdef ACL2_BOOK_DIRS
ifndef ACL2_CENTAUR
ACL2_CENTAUR ?= skip
endif
else
ACL2_CENTAUR ?= before
# The following can be any subset of DIRS2, and can be set by the user
# on the command line, e.g., from the ACL2 sources directory:
#   make -j 8 regression ACL2_BOOK_DIRS='symbolic paco'
# The directory dependencies (below) should guarantee that all
# necessary supporting directories are made before the ones specified
# explicitly in ACL2_BOOK_DIRS.
ACL2_BOOK_DIRS := $(DIRS2)
endif

ALL_PLUS_DIRS = $(DIRS1) $(ACL2_BOOK_DIRS)

ifdef ACL2
	ACL2_FOR_HONS ?= $(ACL2)
	ACL2_FOR_CENTAUR ?= $(ACL2)
else
	ACL2_FOR_HONS ?= `cd .. ; pwd`/saved_acl2h
	ACL2_FOR_CENTAUR ?= `cd .. ; pwd`/saved_acl2
ifdef ACL2_HONS_REGRESSION
# and ACL2 not defined
	export ACL2 = $(shell cd .. ; pwd)/saved_acl2h
endif
endif

# Since we have specified that ACL2_BOOK_DIRS is to be a subset of
# DIRS2, we don't need to add it explicitly on the next line.
.PHONY: $(DIRS1) $(DIRS2)

# Same as all-plus below, using DIRS2_EXCEPT_WK instead of DIRS2.  Much faster!  Omits
# books less likely to be needed, in particular, under workshops/.
all:
	@date ; $(TIME) $(MAKE) all-aux


# Next, specify all of the directory dependencies.  At this point we do this
# manually by inspecting the Makefiles.

arithmetic: cowles
data-structures: arithmetic
meta: arithmetic
ordinals: top-with-meta-cert
ihs: arithmetic data-structures
misc: data-structures top-with-meta-cert ordinals arithmetic ihs arithmetic-2 arithmetic-3
make-event: misc arithmetic-3 arithmetic rtl
arithmetic-2: ihs
rtl: arithmetic meta top-with-meta-cert ordinals ihs misc arithmetic-2
# arithmetic-3 has no dependencies (but see arithmetic-3/extra)
arithmetic-3/extra: arithmetic-3 ihs rtl arithmetic-2 arithmetic-3
# arithmetic-5 has no dependencies
finite-set-theory: arithmetic ordinals
finite-set-theory/osets: unicode tools
powerlists: arithmetic ordinals data-structures
textbook: arithmetic top-with-meta-cert ordinals ihs
defexec: arithmetic misc ordinals
symbolic: arithmetic arithmetic-2 data-structures ihs misc ordinals models/jvm/m5
data-structures/memories: arithmetic-3 misc
unicode: arithmetic arithmetic-3 ihs ordinals tools misc system
proofstyles: arithmetic-2 ordinals misc top-with-meta-cert
concurrent-programs/bakery: misc ordinals
concurrent-programs/german-protocol: misc
deduction/passmore: 
serialize: tools
clause-processors: top-with-meta-cert arithmetic-3 textbook arithmetic \
	misc tools data-structures arithmetic-5 system
quadratic-reciprocity: rtl
misc/misc2: rtl coi top-with-meta-cert
hints: misc
models/jvm/m1-original: arithmetic-3/extra
models/jvm/m1: arithmetic-5
models/jvm/m5: top-with-meta-cert ordinals misc ihs
# models/jvm/m5 is needed for paco/books, not paco
models/X86: tools arithmetic-5 arithmetic misc rtl defexec
paco: ihs ordinals top-with-meta-cert
hacking: misc
parallel: make-event tools
security: misc arithmetic-3 arithmetic-5
security/des: security misc centaur
sorting: arithmetic-3/extra
tools: arithmetic-5 misc xdoc
regex: tools cutil str misc
defsort: misc unicode tools
str: arithmetic unicode defsort tools xdoc misc
coi: arithmetic arithmetic-2 arithmetic-3 data-structures ihs make-event \
	misc ordinals rtl
wp-gen: ordinals
# xdoc has no dependencies
xdoc-impl: xdoc str tools finite-set-theory/osets
system: tools arithmetic arithmetic-5 misc
cutil: xdoc xdoc-impl tools str misc finite-set-theory/osets \
       defsort unicode clause-processors
countereg-gen: xdoc arithmetic-5 tools defexec finite-set-theory/osets \
	arithmetic-3 arithmetic ordinals
leftist-trees: arithmetic-5 sorting
demos: make-event cutil misc tools arithmetic
taspi: misc arithmetic-3
models/y86: tools centaur misc arithmetic-5 rtl arithmetic defexec

# Let us wait for everything else before workshops.  Starting after
# Version_4.3 we include the coi books, because of
# workshops/2006/pike-shields-matthews/.
workshops: $(DIRS1) $(DIRS2_EXCEPT_WK)

$(DIRS1):
	@if [ -f $@/Makefile ]; then cd $@ ; $(MAKE) ; fi

$(DIRS2): top-with-meta-cert
	@if [ -f $@/Makefile ]; then cd $@ ; $(MAKE) ; fi

.PHONY: all-aux
all-aux: $(DIRS1) $(DIRS2_EXCEPT_WK)

# Certify all books that need certification.  If you want to get a
# total time for certifying all books, then first do "make clean".  By
# default we do the centaur books first, because one of them might
# support a non-centaur book.  This is quite a commitment: henceforth,
# the regression could in theory fail if we remove the centaur books
# (say, because someone has a problem with Perl).  We'll face that
# problem if it occurs; for example, we could remove the "offending"
# directory from DIRS2_EXCEPT_WK_COI, or we could use
# ACL2_CENTAUR=skip on the command line.

.PHONY: all-plus centaur

ifeq ($(ACL2_CENTAUR),before)
all-plus: $(ALL_PLUS_DIRS)
$(ALL_PLUS_DIRS): centaur
else
ifeq ($(ACL2_CENTAUR),after)
all-plus: centaur
centaur: $(ALL_PLUS_DIRS)
else
all-plus: $(ALL_PLUS_DIRS)
endif
endif

.PHONY: hons clean-hons
# For a parallel "make hons", use e.g.:
#   make hons ACL2_HONS_OPT="-j4"
# In general, ACL2_HONS_OPT is passed to the cert.pl command in centaur/.
# Note that this variable is set automatically in ../GNUmakefile using
# ACL2_JOBS.
hons:
	./cert.pl --targets regression-hons-targets \
	  $(ACL2_HONS_OPT) \
	  --acl2-books "`pwd`" \
	  --acl2 $(ACL2_FOR_HONS)

# WARNING: clean-hons will clean everywhere relevant to books/centaur/ under
# the books/ directory, not merely under books/centaur/.
clean-hons:
	rm -rf centaur/manual
	./cert.pl -c centaur/doc.lisp \
	  $(ACL2_HONS_OPT) \
	  --acl2-books "`pwd`" \
	  -q
	cd taspi/ ; make clean

# Clean all books, not only the "basic" ones.
.PHONY: clean
clean:
	@for dir in $(DIRS1) $(DIRS2) $(HONS_ONLY_DIRS) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) FAST_DEPS_FOR_CLEAN=1 clean ; \
	cd ..) ; \
	fi \
	done

# See instructions for hons above -- except we expect to use the
# centaur target with vanilla ACL2, as opposed to ACL2(h).
centaur:
	./cert.pl --targets regression-centaur-targets \
	  $(ACL2_HONS_OPT) \
	  --acl2-books "`pwd`" \
	  --acl2 $(ACL2_FOR_CENTAUR)

# WARNING: clean-centaur will clean everywhere relevant to books/centaur/ under
# the books/ directory, not merely under books/centaur/.
.PHONY: clean-centaur
ifeq ($(ACL2_CENTAUR),skip)
clean-centaur:
	@echo "Skipping actions for clean-centaur."
else
clean-centaur:
	rm -rf centaur/manual
	./cert.pl -c centaur/doc.lisp \
	  $(ACL2_HONS_OPT) \
	  --acl2-books "`pwd`" \
	  -q
endif

.PHONY: clean
clean: clean-centaur

# Tar up books and support, not including workshops or nonstd stuff.
.PHONY: tar
tar:
	tar cvf books.tar Makefile Makefile-generic Makefile-subdirs README README.html certify-numbers.lsp $(DIRS1) $(DIRS2_EXCEPT_WK)

# The following "short" targets allow for a relatively short test, in response
# to a request from GCL maintainer Camm Maguire.

.PHONY: short-clean
short-clean:
	@rm -f short-test.log
	@for dir in $(DIRS1) $(SHORTDIRS2) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) clean ; \
	cd ..) ; \
	fi \
	done

.PHONY: short-test-aux
short-test-aux:
	@for dir in $(DIRS1) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) all ; \
	cd ..) ; \
	fi \
	done
	@$(MAKE) top-with-meta-cert
	@for dir in $(SHORTDIRS2) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) all ; \
	cd ..) ; \
	fi \
	done

.PHONY: short-test
short-test:
	@rm -f short-test.log
	$(MAKE) short-clean
	$(MAKE) short-test-aux > short-test.log 2> short-test.log
	@if [ ! -f short-test.log ] || (fgrep '**' short-test.log > /dev/null) ; then \
	(echo 'Short test failed!' ; exit 1) ; else \
	echo 'Short test passed.' ; fi

# The following target is primarily for developers to be able to check
# well-formedness of the ACL2 world after including each book.
# WARNING: Be sure to run "make regression" first!
# The explicit make of top-with-meta.cert is there in order to avoid
# removing that file after the .bkchk.out file is made (which
# otherwise happens, somehow!).

=== parallel/Makefile ===
# Avoid provisional certification since it fails, probably because of
# the unusual use of ACL2_COMPILE_FLG below.  Also, since this
# directory exercises ACL2(p)-level parallelism, perhaps it's just as
# well not to chance increasing make-level parallelism with
# provisional certification.
override ACL2_PCERT =

# It can be useful to extend the :all target for use in ACL2(p)
# regressions, as shown just below.  However, we have seen the first
# theorem in proofs/ideal-speedup.lisp, ideal-4-way, take over 9 hours
# using ACL2(h) built on CCL with safety 3, on a fast 2012-vintage
# Linux machine.  So we avoid adding certification of that book to the
# default regression.
#
# all: proofs/ideal-speedup.cert

matrix-multiplication-parallel.cert: matrix-multiplication-serial.cert
fibonacci.cert: matrix-multiplication-parallel.cert

DIRS = proofs

include ../Makefile-subdirs
include ../Makefile-generic
-include Makefile-deps

# This is really gross and taken from the xdoc directory for lack of knowing of
# something better.
ACL2_COMPILE_FLG := t :ttags :all

# Additional dependencies to force serialization when set-compile-fns is set
# (causes a problem for GCL 2.6.*).

=== system/Makefile ===
system-top: top all
all: top

DIRS = pcert
include ../Makefile-generic
include ../Makefile-subdirs

-include Makefile-deps

=== xdoc-impl/Makefile ===
include ../Makefile-generic
-include Makefile-deps

all: $(BOOKS_CERT) bookdoc.dat

.PHONY: moreclean
moreclean:
	rm -rf manual
	rm -rf *.time
	rm -rf bookdoc.dat

clean: moreclean

# Goofy.  We don't want to actually list the dependencies of bookdoc.dat.  In
# principle, we should rebuild it any time any Lisp file in :dir :system is
# changed (and it should be smart enough to figure out which books have
# documentation on its own).  But this is hard.  I don't want to manually
# maintain a giant list of lisp files that bookdoc.dat depends on, and
# automatic dependency scanning is painful in GNU Make, so I don't want to deal
# with it.
#
# (On the above point, added by Matt K.: When we certify with the
# saving of expansion files, as is the case for "make regression" with
# ACL2_SAVE_EXPANSION=t, we create many files *@expansion.lsp.  Since
# there are only three .lsp source files, we enumerate them explicitly
# below in the dependencies for bookdoc.dat.)
#
# Practically speaking, it isn't really crucial that bookdoc.dat be rebuilt all
# the time.  Documentation really isn't updated that frequently, and even if
# the documentation in bookdoc.dat is out of date, the (maybe-import-bookdoc)
# command only adds topics that aren't already loaded, so the user won't see
# outdated documentation at runtime with :xdoc unless they're looking at a
# topic in a book that they haven't loaded.  I think it's reasonable to accept
# this.

bookdoc.dat: acl2-customization.lsp bookdoc.lsp ../xdoc/package.lsp \
             $(wildcard ../xdoc/*.lisp) \
             $(wildcard *.lisp) \
             extra-packages.cert
	@$(ACL2) < bookdoc.lsp > bookdoc.out
	@ls -l bookdoc.dat

make-manual.cert: bookdoc.dat

=== centaur/quicklisp/Makefile ===
# Quicklisp setup for Centaur books
# Copyright (C) 2008-2012 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.  You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
#
# Original author: Jared Davis <jared@centtech.com>

STARTJOB ?= $(SHELL)
ACL2 ?= acl2

all: top.cert

quicklisp.lisp:
	curl -O http://beta.quicklisp.org/quicklisp.lisp

setup.lisp: quicklisp.lisp install.lsp
	$(STARTJOB) -c "$(ACL2) < install.lsp &> install.out"

clean:
	rm -rf setup.lisp quicklisp.lisp asdf.lisp cache dists local-projects \
	       tmp install.out quicklisp *.cert.out *.cert.time *.lx64fsl Makefile-tmp

top.cert: setup.lisp
	cert.pl top.cert

=== system/pcert/Makefile ===
# Cause provisional certification in this directory
ACL2_PCERT ?= t
include ../../Makefile-generic
-include Makefile-deps

# Added manually, for the case of provisional certification
# (ACL2_PCERT=t); see last form in .lisp file.
acl2x-pcert-test-2-include.pcert0: acl2x-pcert-test-2.cert

# Override:
acl2x-pcert-test-2.acl2x:
	cp -p acl2x-pcert-test-2.acl2x-source acl2x-pcert-test-2.acl2x

=== models/y86/y86-two-level-abs/examples/Makefile ===
include ../../../../Makefile-generic
-include Makefile-deps
# Avoid popcount-demo.lisp, which is more or less subsumed by
# popcount.lisp and might otherwise be done in parallel with it
# (depending on how `make' is invoked), resulting in memory usage that
# stresses a machine with 8GB of RAM.
BOOKS = popcount

=== debian/changelog ===
acl2 (6.0-2) unstable; urgency=low

  * HOME="/tmp" environment for make DOC

 -- Camm Maguire <camm@debian.org>  Sun, 13 Jan 2013 17:54:15 +0000

acl2 (6.0-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 07 Jan 2013 21:45:40 +0000

acl2 (5.0-1) unstable; urgency=low

  * New upstream release
  * books retrieved separately from http://acl2-books.googlecode.com/files/books-5.0.tar.gz
  * Bug fix: "Should build-depend on emacs23 | emacs24", thanks to
    svante.signell@telia.com</a>; (Closes: #682719).

 -- Camm Maguire <camm@debian.org>  Fri, 24 Aug 2012 18:45:28 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.7-100 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common
Standards-Version: 3.9.3

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs24 | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

books/workshops:
	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2: $(DLOPEN_T) #debian/patches_applied 
	echo '(progn (load "debian/sublis_patch.lsp")(si::save-system "pgcl"))' | gcl
	./pgcl -batch -eval "(bye #-native-reloc 1)" || \
		(./pgcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
	./pgcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) LISP=./pgcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q #+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	$(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	$(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	cd books && \
		BUILDDIR="$$(dirname $$(pwd))" \
		FINALDIR="/usr/share/$(PD)" \
		HOME="/tmp/" \
		$(MAKE) ACL2_CENTAUR=skip >../$@ 2>&1 & j=$$! ; \
		tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \
		wait $$j
	[ -f $@ ] && ! fgrep '**' $@ || echo FULL TEST FAILS
	for i in $$(find books -name "*.out"); do \
		if ! [ -e $${i%out}cert ] ; then \
			echo $$i ; \
			cat $$i ; \
		fi ; \
	done
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ! fgrep '**' $@

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME="/tmp/" $(MAKE) DOC

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

clean: books/workshops infix_clean #debian/patches_unapplied
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rmdir $<
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt
	dh_clean -XTAGS

debian/acl2-infix.install:: 
	find books/interface/infix -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	find books/interface/infix -name "*.sty" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/texmf/tex/latex\n",$$1);}' >>$@

debian/acl2-infix-source.install:: 
	find books/interface/infix -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-emacs.install:: 
	find books/interface/emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@
	find emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@

debian/acl2.install:: 
	echo debian/acl2.sh usr/bin >>$@
	echo saved_acl2 usr/lib/$(PD) >>$@

debian/acl2-books.install:: 
	find books -name "*.o" | grep -v interface/ | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-source.install:: 
	find * -name "*.lisp" -maxdepth 0 | grep -v TMP1.lisp | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >$@
	find * -name "TAGS" -maxdepth 0 | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >>$@

debian/acl2-books-certs.install:: 
	find books -name "*.cert" | grep -v fix-cert/moved | grep -v system/pcert | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s.final usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find books -name "*.pcert0.final" | \
		awk '{a=$$1;sub(".pcert0.final",".cert",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-books-source.install:: 
	find books -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find books -name "*.acl2" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
